# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.boolean_type import BooleanType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.canonical_type import CanonicalType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.code_type import CodeType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.codeable_concept import CodeableConcept  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.concept_map_group_component import ConceptMapGroupComponent  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.contact_detail import ContactDetail  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.date_time_type import DateTimeType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.enumeration_publication_status import EnumerationPublicationStatus  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.id_type import IdType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.identifier import Identifier  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.markdown_type import MarkdownType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.meta import Meta  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.narrative import Narrative  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.resource import Resource  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.type import Type  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.uri_type import UriType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.usage_context import UsageContext  # noqa: F401,E501


class ConceptMap(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'meta': 'Meta',
        'implicit_rules': 'str',
        'language': 'str',
        'text': 'Narrative',
        'contained': 'list[Resource]',
        'extension': 'list[Extension]',
        'modifier_extension': 'list[Extension]',
        'url': 'str',
        'version': 'str',
        'name': 'str',
        'title': 'str',
        'status': 'str',
        'experimental': 'bool',
        'date': 'datetime',
        'publisher': 'str',
        'contact': 'list[ContactDetail]',
        'description': 'str',
        'use_context': 'list[UsageContext]',
        'jurisdiction': 'list[CodeableConcept]',
        'identifier': 'Identifier',
        'purpose': 'str',
        'copyright': 'str',
        'source': 'Type',
        'target': 'Type',
        'group': 'list[ConceptMapGroupComponent]',
        'resource_type': 'str',
        'url_element': 'UriType',
        'version_element': 'StringType',
        'name_element': 'StringType',
        'title_element': 'StringType',
        'status_element': 'EnumerationPublicationStatus',
        'experimental_element': 'BooleanType',
        'date_element': 'DateTimeType',
        'publisher_element': 'StringType',
        'contact_first_rep': 'ContactDetail',
        'description_element': 'MarkdownType',
        'use_context_first_rep': 'UsageContext',
        'jurisdiction_first_rep': 'CodeableConcept',
        'purpose_element': 'MarkdownType',
        'copyright_element': 'MarkdownType',
        'source_uri_type': 'UriType',
        'source_canonical_type': 'CanonicalType',
        'target_uri_type': 'UriType',
        'target_canonical_type': 'CanonicalType',
        'group_first_rep': 'ConceptMapGroupComponent',
        'empty': 'bool',
        'id_element': 'IdType',
        'language_element': 'CodeType',
        'structure_fhir_version_enum': 'str',
        'implicit_rules_element': 'UriType',
        'id_base': 'str',
        'resource': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool',
        'primitive': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'meta': 'meta',
        'implicit_rules': 'implicitRules',
        'language': 'language',
        'text': 'text',
        'contained': 'contained',
        'extension': 'extension',
        'modifier_extension': 'modifierExtension',
        'url': 'url',
        'version': 'version',
        'name': 'name',
        'title': 'title',
        'status': 'status',
        'experimental': 'experimental',
        'date': 'date',
        'publisher': 'publisher',
        'contact': 'contact',
        'description': 'description',
        'use_context': 'useContext',
        'jurisdiction': 'jurisdiction',
        'identifier': 'identifier',
        'purpose': 'purpose',
        'copyright': 'copyright',
        'source': 'source',
        'target': 'target',
        'group': 'group',
        'resource_type': 'resourceType',
        'url_element': 'urlElement',
        'version_element': 'versionElement',
        'name_element': 'nameElement',
        'title_element': 'titleElement',
        'status_element': 'statusElement',
        'experimental_element': 'experimentalElement',
        'date_element': 'dateElement',
        'publisher_element': 'publisherElement',
        'contact_first_rep': 'contactFirstRep',
        'description_element': 'descriptionElement',
        'use_context_first_rep': 'useContextFirstRep',
        'jurisdiction_first_rep': 'jurisdictionFirstRep',
        'purpose_element': 'purposeElement',
        'copyright_element': 'copyrightElement',
        'source_uri_type': 'sourceUriType',
        'source_canonical_type': 'sourceCanonicalType',
        'target_uri_type': 'targetUriType',
        'target_canonical_type': 'targetCanonicalType',
        'group_first_rep': 'groupFirstRep',
        'empty': 'empty',
        'id_element': 'idElement',
        'language_element': 'languageElement',
        'structure_fhir_version_enum': 'structureFhirVersionEnum',
        'implicit_rules_element': 'implicitRulesElement',
        'id_base': 'idBase',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime',
        'primitive': 'primitive'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, meta=None, implicit_rules=None, language=None, text=None, contained=None, extension=None, modifier_extension=None, url=None, version=None, name=None, title=None, status=None, experimental=None, date=None, publisher=None, contact=None, description=None, use_context=None, jurisdiction=None, identifier=None, purpose=None, copyright=None, source=None, target=None, group=None, resource_type=None, url_element=None, version_element=None, name_element=None, title_element=None, status_element=None, experimental_element=None, date_element=None, publisher_element=None, contact_first_rep=None, description_element=None, use_context_first_rep=None, jurisdiction_first_rep=None, purpose_element=None, copyright_element=None, source_uri_type=None, source_canonical_type=None, target_uri_type=None, target_canonical_type=None, group_first_rep=None, empty=None, id_element=None, language_element=None, structure_fhir_version_enum=None, implicit_rules_element=None, id_base=None, resource=None, boolean_primitive=None, date_time=None, primitive=None):  # noqa: E501
        """ConceptMap - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._meta = None
        self._implicit_rules = None
        self._language = None
        self._text = None
        self._contained = None
        self._extension = None
        self._modifier_extension = None
        self._url = None
        self._version = None
        self._name = None
        self._title = None
        self._status = None
        self._experimental = None
        self._date = None
        self._publisher = None
        self._contact = None
        self._description = None
        self._use_context = None
        self._jurisdiction = None
        self._identifier = None
        self._purpose = None
        self._copyright = None
        self._source = None
        self._target = None
        self._group = None
        self._resource_type = None
        self._url_element = None
        self._version_element = None
        self._name_element = None
        self._title_element = None
        self._status_element = None
        self._experimental_element = None
        self._date_element = None
        self._publisher_element = None
        self._contact_first_rep = None
        self._description_element = None
        self._use_context_first_rep = None
        self._jurisdiction_first_rep = None
        self._purpose_element = None
        self._copyright_element = None
        self._source_uri_type = None
        self._source_canonical_type = None
        self._target_uri_type = None
        self._target_canonical_type = None
        self._group_first_rep = None
        self._empty = None
        self._id_element = None
        self._language_element = None
        self._structure_fhir_version_enum = None
        self._implicit_rules_element = None
        self._id_base = None
        self._resource = None
        self._boolean_primitive = None
        self._date_time = None
        self._primitive = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if meta is not None:
            self.meta = meta
        if implicit_rules is not None:
            self.implicit_rules = implicit_rules
        if language is not None:
            self.language = language
        if text is not None:
            self.text = text
        if contained is not None:
            self.contained = contained
        if extension is not None:
            self.extension = extension
        if modifier_extension is not None:
            self.modifier_extension = modifier_extension
        if url is not None:
            self.url = url
        if version is not None:
            self.version = version
        if name is not None:
            self.name = name
        if title is not None:
            self.title = title
        if status is not None:
            self.status = status
        if experimental is not None:
            self.experimental = experimental
        if date is not None:
            self.date = date
        if publisher is not None:
            self.publisher = publisher
        if contact is not None:
            self.contact = contact
        if description is not None:
            self.description = description
        if use_context is not None:
            self.use_context = use_context
        if jurisdiction is not None:
            self.jurisdiction = jurisdiction
        if identifier is not None:
            self.identifier = identifier
        if purpose is not None:
            self.purpose = purpose
        if copyright is not None:
            self.copyright = copyright
        if source is not None:
            self.source = source
        if target is not None:
            self.target = target
        if group is not None:
            self.group = group
        if resource_type is not None:
            self.resource_type = resource_type
        if url_element is not None:
            self.url_element = url_element
        if version_element is not None:
            self.version_element = version_element
        if name_element is not None:
            self.name_element = name_element
        if title_element is not None:
            self.title_element = title_element
        if status_element is not None:
            self.status_element = status_element
        if experimental_element is not None:
            self.experimental_element = experimental_element
        if date_element is not None:
            self.date_element = date_element
        if publisher_element is not None:
            self.publisher_element = publisher_element
        if contact_first_rep is not None:
            self.contact_first_rep = contact_first_rep
        if description_element is not None:
            self.description_element = description_element
        if use_context_first_rep is not None:
            self.use_context_first_rep = use_context_first_rep
        if jurisdiction_first_rep is not None:
            self.jurisdiction_first_rep = jurisdiction_first_rep
        if purpose_element is not None:
            self.purpose_element = purpose_element
        if copyright_element is not None:
            self.copyright_element = copyright_element
        if source_uri_type is not None:
            self.source_uri_type = source_uri_type
        if source_canonical_type is not None:
            self.source_canonical_type = source_canonical_type
        if target_uri_type is not None:
            self.target_uri_type = target_uri_type
        if target_canonical_type is not None:
            self.target_canonical_type = target_canonical_type
        if group_first_rep is not None:
            self.group_first_rep = group_first_rep
        if empty is not None:
            self.empty = empty
        if id_element is not None:
            self.id_element = id_element
        if language_element is not None:
            self.language_element = language_element
        if structure_fhir_version_enum is not None:
            self.structure_fhir_version_enum = structure_fhir_version_enum
        if implicit_rules_element is not None:
            self.implicit_rules_element = implicit_rules_element
        if id_base is not None:
            self.id_base = id_base
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time
        if primitive is not None:
            self.primitive = primitive

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this ConceptMap.  # noqa: E501


        :return: The format_comments_pre of this ConceptMap.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this ConceptMap.


        :param format_comments_pre: The format_comments_pre of this ConceptMap.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this ConceptMap.  # noqa: E501


        :return: The format_comments_post of this ConceptMap.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this ConceptMap.


        :param format_comments_post: The format_comments_post of this ConceptMap.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this ConceptMap.  # noqa: E501


        :return: The id of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ConceptMap.


        :param id: The id of this ConceptMap.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def meta(self):
        """Gets the meta of this ConceptMap.  # noqa: E501


        :return: The meta of this ConceptMap.  # noqa: E501
        :rtype: Meta
        """
        return self._meta

    @meta.setter
    def meta(self, meta):
        """Sets the meta of this ConceptMap.


        :param meta: The meta of this ConceptMap.  # noqa: E501
        :type: Meta
        """

        self._meta = meta

    @property
    def implicit_rules(self):
        """Gets the implicit_rules of this ConceptMap.  # noqa: E501


        :return: The implicit_rules of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._implicit_rules

    @implicit_rules.setter
    def implicit_rules(self, implicit_rules):
        """Sets the implicit_rules of this ConceptMap.


        :param implicit_rules: The implicit_rules of this ConceptMap.  # noqa: E501
        :type: str
        """

        self._implicit_rules = implicit_rules

    @property
    def language(self):
        """Gets the language of this ConceptMap.  # noqa: E501


        :return: The language of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._language

    @language.setter
    def language(self, language):
        """Sets the language of this ConceptMap.


        :param language: The language of this ConceptMap.  # noqa: E501
        :type: str
        """

        self._language = language

    @property
    def text(self):
        """Gets the text of this ConceptMap.  # noqa: E501


        :return: The text of this ConceptMap.  # noqa: E501
        :rtype: Narrative
        """
        return self._text

    @text.setter
    def text(self, text):
        """Sets the text of this ConceptMap.


        :param text: The text of this ConceptMap.  # noqa: E501
        :type: Narrative
        """

        self._text = text

    @property
    def contained(self):
        """Gets the contained of this ConceptMap.  # noqa: E501


        :return: The contained of this ConceptMap.  # noqa: E501
        :rtype: list[Resource]
        """
        return self._contained

    @contained.setter
    def contained(self, contained):
        """Sets the contained of this ConceptMap.


        :param contained: The contained of this ConceptMap.  # noqa: E501
        :type: list[Resource]
        """

        self._contained = contained

    @property
    def extension(self):
        """Gets the extension of this ConceptMap.  # noqa: E501


        :return: The extension of this ConceptMap.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this ConceptMap.


        :param extension: The extension of this ConceptMap.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def modifier_extension(self):
        """Gets the modifier_extension of this ConceptMap.  # noqa: E501


        :return: The modifier_extension of this ConceptMap.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._modifier_extension

    @modifier_extension.setter
    def modifier_extension(self, modifier_extension):
        """Sets the modifier_extension of this ConceptMap.


        :param modifier_extension: The modifier_extension of this ConceptMap.  # noqa: E501
        :type: list[Extension]
        """

        self._modifier_extension = modifier_extension

    @property
    def url(self):
        """Gets the url of this ConceptMap.  # noqa: E501


        :return: The url of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this ConceptMap.


        :param url: The url of this ConceptMap.  # noqa: E501
        :type: str
        """

        self._url = url

    @property
    def version(self):
        """Gets the version of this ConceptMap.  # noqa: E501


        :return: The version of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this ConceptMap.


        :param version: The version of this ConceptMap.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def name(self):
        """Gets the name of this ConceptMap.  # noqa: E501


        :return: The name of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ConceptMap.


        :param name: The name of this ConceptMap.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def title(self):
        """Gets the title of this ConceptMap.  # noqa: E501


        :return: The title of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this ConceptMap.


        :param title: The title of this ConceptMap.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def status(self):
        """Gets the status of this ConceptMap.  # noqa: E501


        :return: The status of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ConceptMap.


        :param status: The status of this ConceptMap.  # noqa: E501
        :type: str
        """
        allowed_values = ["DRAFT", "ACTIVE", "RETIRED", "UNKNOWN", "NULL"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def experimental(self):
        """Gets the experimental of this ConceptMap.  # noqa: E501


        :return: The experimental of this ConceptMap.  # noqa: E501
        :rtype: bool
        """
        return self._experimental

    @experimental.setter
    def experimental(self, experimental):
        """Sets the experimental of this ConceptMap.


        :param experimental: The experimental of this ConceptMap.  # noqa: E501
        :type: bool
        """

        self._experimental = experimental

    @property
    def date(self):
        """Gets the date of this ConceptMap.  # noqa: E501


        :return: The date of this ConceptMap.  # noqa: E501
        :rtype: datetime
        """
        return self._date

    @date.setter
    def date(self, date):
        """Sets the date of this ConceptMap.


        :param date: The date of this ConceptMap.  # noqa: E501
        :type: datetime
        """

        self._date = date

    @property
    def publisher(self):
        """Gets the publisher of this ConceptMap.  # noqa: E501


        :return: The publisher of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._publisher

    @publisher.setter
    def publisher(self, publisher):
        """Sets the publisher of this ConceptMap.


        :param publisher: The publisher of this ConceptMap.  # noqa: E501
        :type: str
        """

        self._publisher = publisher

    @property
    def contact(self):
        """Gets the contact of this ConceptMap.  # noqa: E501


        :return: The contact of this ConceptMap.  # noqa: E501
        :rtype: list[ContactDetail]
        """
        return self._contact

    @contact.setter
    def contact(self, contact):
        """Sets the contact of this ConceptMap.


        :param contact: The contact of this ConceptMap.  # noqa: E501
        :type: list[ContactDetail]
        """

        self._contact = contact

    @property
    def description(self):
        """Gets the description of this ConceptMap.  # noqa: E501


        :return: The description of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ConceptMap.


        :param description: The description of this ConceptMap.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def use_context(self):
        """Gets the use_context of this ConceptMap.  # noqa: E501


        :return: The use_context of this ConceptMap.  # noqa: E501
        :rtype: list[UsageContext]
        """
        return self._use_context

    @use_context.setter
    def use_context(self, use_context):
        """Sets the use_context of this ConceptMap.


        :param use_context: The use_context of this ConceptMap.  # noqa: E501
        :type: list[UsageContext]
        """

        self._use_context = use_context

    @property
    def jurisdiction(self):
        """Gets the jurisdiction of this ConceptMap.  # noqa: E501


        :return: The jurisdiction of this ConceptMap.  # noqa: E501
        :rtype: list[CodeableConcept]
        """
        return self._jurisdiction

    @jurisdiction.setter
    def jurisdiction(self, jurisdiction):
        """Sets the jurisdiction of this ConceptMap.


        :param jurisdiction: The jurisdiction of this ConceptMap.  # noqa: E501
        :type: list[CodeableConcept]
        """

        self._jurisdiction = jurisdiction

    @property
    def identifier(self):
        """Gets the identifier of this ConceptMap.  # noqa: E501


        :return: The identifier of this ConceptMap.  # noqa: E501
        :rtype: Identifier
        """
        return self._identifier

    @identifier.setter
    def identifier(self, identifier):
        """Sets the identifier of this ConceptMap.


        :param identifier: The identifier of this ConceptMap.  # noqa: E501
        :type: Identifier
        """

        self._identifier = identifier

    @property
    def purpose(self):
        """Gets the purpose of this ConceptMap.  # noqa: E501


        :return: The purpose of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._purpose

    @purpose.setter
    def purpose(self, purpose):
        """Sets the purpose of this ConceptMap.


        :param purpose: The purpose of this ConceptMap.  # noqa: E501
        :type: str
        """

        self._purpose = purpose

    @property
    def copyright(self):
        """Gets the copyright of this ConceptMap.  # noqa: E501


        :return: The copyright of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._copyright

    @copyright.setter
    def copyright(self, copyright):
        """Sets the copyright of this ConceptMap.


        :param copyright: The copyright of this ConceptMap.  # noqa: E501
        :type: str
        """

        self._copyright = copyright

    @property
    def source(self):
        """Gets the source of this ConceptMap.  # noqa: E501


        :return: The source of this ConceptMap.  # noqa: E501
        :rtype: Type
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this ConceptMap.


        :param source: The source of this ConceptMap.  # noqa: E501
        :type: Type
        """

        self._source = source

    @property
    def target(self):
        """Gets the target of this ConceptMap.  # noqa: E501


        :return: The target of this ConceptMap.  # noqa: E501
        :rtype: Type
        """
        return self._target

    @target.setter
    def target(self, target):
        """Sets the target of this ConceptMap.


        :param target: The target of this ConceptMap.  # noqa: E501
        :type: Type
        """

        self._target = target

    @property
    def group(self):
        """Gets the group of this ConceptMap.  # noqa: E501


        :return: The group of this ConceptMap.  # noqa: E501
        :rtype: list[ConceptMapGroupComponent]
        """
        return self._group

    @group.setter
    def group(self, group):
        """Sets the group of this ConceptMap.


        :param group: The group of this ConceptMap.  # noqa: E501
        :type: list[ConceptMapGroupComponent]
        """

        self._group = group

    @property
    def resource_type(self):
        """Gets the resource_type of this ConceptMap.  # noqa: E501


        :return: The resource_type of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this ConceptMap.


        :param resource_type: The resource_type of this ConceptMap.  # noqa: E501
        :type: str
        """
        allowed_values = ["Account", "ActivityDefinition", "AdverseEvent", "AllergyIntolerance", "Appointment", "AppointmentResponse", "AuditEvent", "Basic", "Binary", "BiologicallyDerivedProduct", "BodyStructure", "Bundle", "CapabilityStatement", "CarePlan", "CareTeam", "CatalogEntry", "ChargeItem", "ChargeItemDefinition", "Claim", "ClaimResponse", "ClinicalImpression", "CodeSystem", "Communication", "CommunicationRequest", "CompartmentDefinition", "Composition", "ConceptMap", "Condition", "Consent", "Contract", "Coverage", "CoverageEligibilityRequest", "CoverageEligibilityResponse", "DetectedIssue", "Device", "DeviceDefinition", "DeviceMetric", "DeviceRequest", "DeviceUseStatement", "DiagnosticReport", "DocumentManifest", "DocumentReference", "EffectEvidenceSynthesis", "Encounter", "Endpoint", "EnrollmentRequest", "EnrollmentResponse", "EpisodeOfCare", "EventDefinition", "Evidence", "EvidenceVariable", "ExampleScenario", "ExplanationOfBenefit", "FamilyMemberHistory", "Flag", "Goal", "GraphDefinition", "Group", "GuidanceResponse", "HealthcareService", "ImagingStudy", "Immunization", "ImmunizationEvaluation", "ImmunizationRecommendation", "ImplementationGuide", "InsurancePlan", "Invoice", "Library", "Linkage", "List", "Location", "Measure", "MeasureReport", "Media", "Medication", "MedicationAdministration", "MedicationDispense", "MedicationKnowledge", "MedicationRequest", "MedicationStatement", "MedicinalProduct", "MedicinalProductAuthorization", "MedicinalProductContraindication", "MedicinalProductIndication", "MedicinalProductIngredient", "MedicinalProductInteraction", "MedicinalProductManufactured", "MedicinalProductPackaged", "MedicinalProductPharmaceutical", "MedicinalProductUndesirableEffect", "MessageDefinition", "MessageHeader", "MolecularSequence", "NamingSystem", "NutritionOrder", "Observation", "ObservationDefinition", "OperationDefinition", "OperationOutcome", "Organization", "OrganizationAffiliation", "Parameters", "Patient", "PaymentNotice", "PaymentReconciliation", "Person", "PlanDefinition", "Practitioner", "PractitionerRole", "Procedure", "Provenance", "Questionnaire", "QuestionnaireResponse", "RelatedPerson", "RequestGroup", "ResearchDefinition", "ResearchElementDefinition", "ResearchStudy", "ResearchSubject", "RiskAssessment", "RiskEvidenceSynthesis", "Schedule", "SearchParameter", "ServiceRequest", "Slot", "Specimen", "SpecimenDefinition", "StructureDefinition", "StructureMap", "Subscription", "Substance", "SubstanceNucleicAcid", "SubstancePolymer", "SubstanceProtein", "SubstanceReferenceInformation", "SubstanceSourceMaterial", "SubstanceSpecification", "SupplyDelivery", "SupplyRequest", "Task", "TerminologyCapabilities", "TestReport", "TestScript", "ValueSet", "VerificationResult", "VisionPrescription"]  # noqa: E501
        if resource_type not in allowed_values:
            raise ValueError(
                "Invalid value for `resource_type` ({0}), must be one of {1}"  # noqa: E501
                .format(resource_type, allowed_values)
            )

        self._resource_type = resource_type

    @property
    def url_element(self):
        """Gets the url_element of this ConceptMap.  # noqa: E501


        :return: The url_element of this ConceptMap.  # noqa: E501
        :rtype: UriType
        """
        return self._url_element

    @url_element.setter
    def url_element(self, url_element):
        """Sets the url_element of this ConceptMap.


        :param url_element: The url_element of this ConceptMap.  # noqa: E501
        :type: UriType
        """

        self._url_element = url_element

    @property
    def version_element(self):
        """Gets the version_element of this ConceptMap.  # noqa: E501


        :return: The version_element of this ConceptMap.  # noqa: E501
        :rtype: StringType
        """
        return self._version_element

    @version_element.setter
    def version_element(self, version_element):
        """Sets the version_element of this ConceptMap.


        :param version_element: The version_element of this ConceptMap.  # noqa: E501
        :type: StringType
        """

        self._version_element = version_element

    @property
    def name_element(self):
        """Gets the name_element of this ConceptMap.  # noqa: E501


        :return: The name_element of this ConceptMap.  # noqa: E501
        :rtype: StringType
        """
        return self._name_element

    @name_element.setter
    def name_element(self, name_element):
        """Sets the name_element of this ConceptMap.


        :param name_element: The name_element of this ConceptMap.  # noqa: E501
        :type: StringType
        """

        self._name_element = name_element

    @property
    def title_element(self):
        """Gets the title_element of this ConceptMap.  # noqa: E501


        :return: The title_element of this ConceptMap.  # noqa: E501
        :rtype: StringType
        """
        return self._title_element

    @title_element.setter
    def title_element(self, title_element):
        """Sets the title_element of this ConceptMap.


        :param title_element: The title_element of this ConceptMap.  # noqa: E501
        :type: StringType
        """

        self._title_element = title_element

    @property
    def status_element(self):
        """Gets the status_element of this ConceptMap.  # noqa: E501


        :return: The status_element of this ConceptMap.  # noqa: E501
        :rtype: EnumerationPublicationStatus
        """
        return self._status_element

    @status_element.setter
    def status_element(self, status_element):
        """Sets the status_element of this ConceptMap.


        :param status_element: The status_element of this ConceptMap.  # noqa: E501
        :type: EnumerationPublicationStatus
        """

        self._status_element = status_element

    @property
    def experimental_element(self):
        """Gets the experimental_element of this ConceptMap.  # noqa: E501


        :return: The experimental_element of this ConceptMap.  # noqa: E501
        :rtype: BooleanType
        """
        return self._experimental_element

    @experimental_element.setter
    def experimental_element(self, experimental_element):
        """Sets the experimental_element of this ConceptMap.


        :param experimental_element: The experimental_element of this ConceptMap.  # noqa: E501
        :type: BooleanType
        """

        self._experimental_element = experimental_element

    @property
    def date_element(self):
        """Gets the date_element of this ConceptMap.  # noqa: E501


        :return: The date_element of this ConceptMap.  # noqa: E501
        :rtype: DateTimeType
        """
        return self._date_element

    @date_element.setter
    def date_element(self, date_element):
        """Sets the date_element of this ConceptMap.


        :param date_element: The date_element of this ConceptMap.  # noqa: E501
        :type: DateTimeType
        """

        self._date_element = date_element

    @property
    def publisher_element(self):
        """Gets the publisher_element of this ConceptMap.  # noqa: E501


        :return: The publisher_element of this ConceptMap.  # noqa: E501
        :rtype: StringType
        """
        return self._publisher_element

    @publisher_element.setter
    def publisher_element(self, publisher_element):
        """Sets the publisher_element of this ConceptMap.


        :param publisher_element: The publisher_element of this ConceptMap.  # noqa: E501
        :type: StringType
        """

        self._publisher_element = publisher_element

    @property
    def contact_first_rep(self):
        """Gets the contact_first_rep of this ConceptMap.  # noqa: E501


        :return: The contact_first_rep of this ConceptMap.  # noqa: E501
        :rtype: ContactDetail
        """
        return self._contact_first_rep

    @contact_first_rep.setter
    def contact_first_rep(self, contact_first_rep):
        """Sets the contact_first_rep of this ConceptMap.


        :param contact_first_rep: The contact_first_rep of this ConceptMap.  # noqa: E501
        :type: ContactDetail
        """

        self._contact_first_rep = contact_first_rep

    @property
    def description_element(self):
        """Gets the description_element of this ConceptMap.  # noqa: E501


        :return: The description_element of this ConceptMap.  # noqa: E501
        :rtype: MarkdownType
        """
        return self._description_element

    @description_element.setter
    def description_element(self, description_element):
        """Sets the description_element of this ConceptMap.


        :param description_element: The description_element of this ConceptMap.  # noqa: E501
        :type: MarkdownType
        """

        self._description_element = description_element

    @property
    def use_context_first_rep(self):
        """Gets the use_context_first_rep of this ConceptMap.  # noqa: E501


        :return: The use_context_first_rep of this ConceptMap.  # noqa: E501
        :rtype: UsageContext
        """
        return self._use_context_first_rep

    @use_context_first_rep.setter
    def use_context_first_rep(self, use_context_first_rep):
        """Sets the use_context_first_rep of this ConceptMap.


        :param use_context_first_rep: The use_context_first_rep of this ConceptMap.  # noqa: E501
        :type: UsageContext
        """

        self._use_context_first_rep = use_context_first_rep

    @property
    def jurisdiction_first_rep(self):
        """Gets the jurisdiction_first_rep of this ConceptMap.  # noqa: E501


        :return: The jurisdiction_first_rep of this ConceptMap.  # noqa: E501
        :rtype: CodeableConcept
        """
        return self._jurisdiction_first_rep

    @jurisdiction_first_rep.setter
    def jurisdiction_first_rep(self, jurisdiction_first_rep):
        """Sets the jurisdiction_first_rep of this ConceptMap.


        :param jurisdiction_first_rep: The jurisdiction_first_rep of this ConceptMap.  # noqa: E501
        :type: CodeableConcept
        """

        self._jurisdiction_first_rep = jurisdiction_first_rep

    @property
    def purpose_element(self):
        """Gets the purpose_element of this ConceptMap.  # noqa: E501


        :return: The purpose_element of this ConceptMap.  # noqa: E501
        :rtype: MarkdownType
        """
        return self._purpose_element

    @purpose_element.setter
    def purpose_element(self, purpose_element):
        """Sets the purpose_element of this ConceptMap.


        :param purpose_element: The purpose_element of this ConceptMap.  # noqa: E501
        :type: MarkdownType
        """

        self._purpose_element = purpose_element

    @property
    def copyright_element(self):
        """Gets the copyright_element of this ConceptMap.  # noqa: E501


        :return: The copyright_element of this ConceptMap.  # noqa: E501
        :rtype: MarkdownType
        """
        return self._copyright_element

    @copyright_element.setter
    def copyright_element(self, copyright_element):
        """Sets the copyright_element of this ConceptMap.


        :param copyright_element: The copyright_element of this ConceptMap.  # noqa: E501
        :type: MarkdownType
        """

        self._copyright_element = copyright_element

    @property
    def source_uri_type(self):
        """Gets the source_uri_type of this ConceptMap.  # noqa: E501


        :return: The source_uri_type of this ConceptMap.  # noqa: E501
        :rtype: UriType
        """
        return self._source_uri_type

    @source_uri_type.setter
    def source_uri_type(self, source_uri_type):
        """Sets the source_uri_type of this ConceptMap.


        :param source_uri_type: The source_uri_type of this ConceptMap.  # noqa: E501
        :type: UriType
        """

        self._source_uri_type = source_uri_type

    @property
    def source_canonical_type(self):
        """Gets the source_canonical_type of this ConceptMap.  # noqa: E501


        :return: The source_canonical_type of this ConceptMap.  # noqa: E501
        :rtype: CanonicalType
        """
        return self._source_canonical_type

    @source_canonical_type.setter
    def source_canonical_type(self, source_canonical_type):
        """Sets the source_canonical_type of this ConceptMap.


        :param source_canonical_type: The source_canonical_type of this ConceptMap.  # noqa: E501
        :type: CanonicalType
        """

        self._source_canonical_type = source_canonical_type

    @property
    def target_uri_type(self):
        """Gets the target_uri_type of this ConceptMap.  # noqa: E501


        :return: The target_uri_type of this ConceptMap.  # noqa: E501
        :rtype: UriType
        """
        return self._target_uri_type

    @target_uri_type.setter
    def target_uri_type(self, target_uri_type):
        """Sets the target_uri_type of this ConceptMap.


        :param target_uri_type: The target_uri_type of this ConceptMap.  # noqa: E501
        :type: UriType
        """

        self._target_uri_type = target_uri_type

    @property
    def target_canonical_type(self):
        """Gets the target_canonical_type of this ConceptMap.  # noqa: E501


        :return: The target_canonical_type of this ConceptMap.  # noqa: E501
        :rtype: CanonicalType
        """
        return self._target_canonical_type

    @target_canonical_type.setter
    def target_canonical_type(self, target_canonical_type):
        """Sets the target_canonical_type of this ConceptMap.


        :param target_canonical_type: The target_canonical_type of this ConceptMap.  # noqa: E501
        :type: CanonicalType
        """

        self._target_canonical_type = target_canonical_type

    @property
    def group_first_rep(self):
        """Gets the group_first_rep of this ConceptMap.  # noqa: E501


        :return: The group_first_rep of this ConceptMap.  # noqa: E501
        :rtype: ConceptMapGroupComponent
        """
        return self._group_first_rep

    @group_first_rep.setter
    def group_first_rep(self, group_first_rep):
        """Sets the group_first_rep of this ConceptMap.


        :param group_first_rep: The group_first_rep of this ConceptMap.  # noqa: E501
        :type: ConceptMapGroupComponent
        """

        self._group_first_rep = group_first_rep

    @property
    def empty(self):
        """Gets the empty of this ConceptMap.  # noqa: E501


        :return: The empty of this ConceptMap.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this ConceptMap.


        :param empty: The empty of this ConceptMap.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def id_element(self):
        """Gets the id_element of this ConceptMap.  # noqa: E501


        :return: The id_element of this ConceptMap.  # noqa: E501
        :rtype: IdType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this ConceptMap.


        :param id_element: The id_element of this ConceptMap.  # noqa: E501
        :type: IdType
        """

        self._id_element = id_element

    @property
    def language_element(self):
        """Gets the language_element of this ConceptMap.  # noqa: E501


        :return: The language_element of this ConceptMap.  # noqa: E501
        :rtype: CodeType
        """
        return self._language_element

    @language_element.setter
    def language_element(self, language_element):
        """Sets the language_element of this ConceptMap.


        :param language_element: The language_element of this ConceptMap.  # noqa: E501
        :type: CodeType
        """

        self._language_element = language_element

    @property
    def structure_fhir_version_enum(self):
        """Gets the structure_fhir_version_enum of this ConceptMap.  # noqa: E501


        :return: The structure_fhir_version_enum of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._structure_fhir_version_enum

    @structure_fhir_version_enum.setter
    def structure_fhir_version_enum(self, structure_fhir_version_enum):
        """Sets the structure_fhir_version_enum of this ConceptMap.


        :param structure_fhir_version_enum: The structure_fhir_version_enum of this ConceptMap.  # noqa: E501
        :type: str
        """
        allowed_values = ["DSTU2", "DSTU2_HL7ORG", "DSTU2_1", "DSTU3", "R4", "R5"]  # noqa: E501
        if structure_fhir_version_enum not in allowed_values:
            raise ValueError(
                "Invalid value for `structure_fhir_version_enum` ({0}), must be one of {1}"  # noqa: E501
                .format(structure_fhir_version_enum, allowed_values)
            )

        self._structure_fhir_version_enum = structure_fhir_version_enum

    @property
    def implicit_rules_element(self):
        """Gets the implicit_rules_element of this ConceptMap.  # noqa: E501


        :return: The implicit_rules_element of this ConceptMap.  # noqa: E501
        :rtype: UriType
        """
        return self._implicit_rules_element

    @implicit_rules_element.setter
    def implicit_rules_element(self, implicit_rules_element):
        """Sets the implicit_rules_element of this ConceptMap.


        :param implicit_rules_element: The implicit_rules_element of this ConceptMap.  # noqa: E501
        :type: UriType
        """

        self._implicit_rules_element = implicit_rules_element

    @property
    def id_base(self):
        """Gets the id_base of this ConceptMap.  # noqa: E501


        :return: The id_base of this ConceptMap.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this ConceptMap.


        :param id_base: The id_base of this ConceptMap.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def resource(self):
        """Gets the resource of this ConceptMap.  # noqa: E501


        :return: The resource of this ConceptMap.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this ConceptMap.


        :param resource: The resource of this ConceptMap.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this ConceptMap.  # noqa: E501


        :return: The boolean_primitive of this ConceptMap.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this ConceptMap.


        :param boolean_primitive: The boolean_primitive of this ConceptMap.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this ConceptMap.  # noqa: E501


        :return: The date_time of this ConceptMap.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this ConceptMap.


        :param date_time: The date_time of this ConceptMap.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    @property
    def primitive(self):
        """Gets the primitive of this ConceptMap.  # noqa: E501


        :return: The primitive of this ConceptMap.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this ConceptMap.


        :param primitive: The primitive of this ConceptMap.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConceptMap):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
